import type { returnType } from '../../_utils';
import type { PropType, ExtractPropTypes } from 'vue';
export declare const iconProps: {
    readonly icon: returnType<PropType<string>, string | null>;
    readonly size: returnType<PropType<string | number>, string | number | null>;
    readonly color: returnType<PropType<string>, string | null>;
};
export type IconProps = ExtractPropTypes<typeof iconProps>;
