import { defineComponent as fe, useSlots as ge, shallowRef as j, computed as q, ref as f, reactive as T, watch as G, resolveComponent as me, openBlock as s, createElementBlock as r, normalizeClass as u, unref as n, normalizeStyle as v, renderSlot as w, createBlock as g, createCommentVNode as a, toDisplayString as m, createElementVNode as L, withDirectives as J, mergeProps as Q, withKeys as ye, vModelDynamic as ke, vShow as xe, nextTick as Pe } from "vue";
import { dkInputProps as ve } from "./index3.js";
import { inputEmits as we } from "./index4.js";
import { getInput as Ie, setPropData as _e, verifyInputType as Ce, setData as Se, getNull as V, getBooleanAnd as W, getValue as Te, getPendValue as Le } from "../../_hooks/get-input/index.js";
import { getReturn as Ve } from "../../_hooks/public/get-return/index.js";
import "../../_icon/index.js";
const be = { key: 1 }, Ae = {
  key: 0,
  class: "dk-input_prefix"
}, $e = ["type", "onKeydown"], De = {
  key: 1,
  class: "dk-input_length"
}, ze = {
  key: 2,
  class: "dk-input_length"
}, Ee = {
  key: 3,
  class: "dk-input_suffix"
}, Re = { key: 1 }, Be = ["type"], Ke = {
  key: 0,
  class: "dk-input_textarea_length"
}, Ne = {
  key: 1,
  class: "dk-input_length"
}, qe = /* @__PURE__ */ fe({
  __name: "input",
  props: ve,
  emits: we,
  setup(X, { emit: c }) {
    const i = X, I = ge(), b = j(), A = j(), k = q(() => b.value || A.value), { classList: $, styleList: D, wrapperClassList: z, innerClassList: Y, pendStyleList: E } = Ie(i), x = f(i.modelValue), R = f(!1), t = _e(i), y = f(i.modelValue);
    let d = !1, h = f(Ce(t.typeProp, d));
    const Z = (e = "") => {
      let o = "";
      return t.maxlengthProp && t.minlengthProp ? o = `${t.minlengthProp}/${t.maxlengthProp}` : t.maxlengthProp ? o = `${e.toString().length}/${t.maxlengthProp}` : t.minlengthProp && (o = `${t.minlengthProp}`), o;
    }, l = Se(t, I, h.value), ee = q(() => V(y.value));
    let _ = Z();
    const B = T({
      isPrependText: W([
        !I.prepend,
        V(t.prependText),
        !l.isPrependIcon
      ]),
      isAppendText: W([
        V(t.appendText),
        !I.append,
        !l.isAppendIcon
      ])
    }), te = ["dk-input_prepend", "dk-input_pend"], ne = ["dk-input_append", "dk-input_pend"], C = f(0);
    G(
      () => i.modelValue,
      () => {
        y.value = Te(
          i.modelValue,
          t.prependText,
          t.prependIcon,
          t.appendText,
          t.appendIcon
        ), x.value = y.value;
      }
    ), G(
      () => y.value,
      (e) => {
        const o = e.toString().length;
        if (t.maxlengthProp && (_ = `${o}/${t.maxlengthProp}`), O().autosize) {
          const p = k.value;
          p.style.height = "auto", p.style.height = `${p.scrollHeight + 2}px`;
        }
        l.showLength && (C.value = o), t.typeProp === "number" ? c("update:modelValue", Number(e)) : c(
          "update:modelValue",
          Le(
            e,
            t.prependText,
            t.prependIcon,
            t.appendText,
            t.appendIcon
          )
        );
      }
    );
    const K = (e) => {
      const o = e.target;
      y.value = o.value;
    }, oe = () => ["dk-input_prefix-icon", typeof t.prefixIcon == "boolean" ? "dk-icon-search" : t.prefixIcon], se = () => ["dk-input_suffix-icon", typeof t.suffixIcon == "boolean" ? "dk-icon-search" : t.suffixIcon], le = () => {
      x.value = "", c("update:modelValue", ""), N();
    }, N = async () => {
      var e;
      await Pe(), (e = k.value) == null || e.focus();
    };
    let H = f("IconPasswordSee");
    const ae = () => {
      var e, o;
      d = !d, H.value = d ? "IconPasswordShow" : "IconPasswordSee", h.value = d ? "text" : "password", d ? (e = k.value) == null || e.setAttribute("type", "text") : (o = k.value) == null || o.setAttribute("type", "password"), N();
    }, pe = () => ["dk-input_password-icon"], F = (e) => {
      R.value = !0, c("focus", e);
    }, M = (e) => {
      R.value = !1, c("blur", e);
    }, { getRun: S } = Ve(), re = (e) => {
      S(i.onAppendClick, e);
    }, ie = (e) => {
      S(i.onPrependClick, e);
    }, ue = (e) => {
      if (e.which === 13) {
        const o = e.target;
        S(i.onEnter, o.value);
      }
    }, O = () => {
      let e = 1;
      const o = h.value === "textarea", p = t.autosizeProp, P = +t.rowsProp, he = P > 0;
      return o && he && (e = P), {
        row: e,
        autosize: o && p
      };
    }, U = (e) => {
      const o = e.target;
      c("change", o.value);
    }, ce = T({
      class: Y.value,
      placeholder: t.placeholder,
      oninput: K,
      disabled: t.disabledProp,
      inputmode: l.inputmode,
      onfocus: F,
      onblur: M,
      onChange: U,
      maxlength: t.maxlengthProp,
      minlength: t.minlengthProp,
      readonly: t.readonlyProp
    }), de = T({
      class: z.value,
      type: h.value,
      placeholder: t.placeholder,
      onInput: K,
      onfocus: F,
      onblur: M,
      onChange: U,
      disabled: t.disabledProp,
      maxlength: t.maxlengthProp,
      minlength: t.minlengthProp,
      autosize: t.autosizeProp,
      rows: O().row,
      readonly: t.readonlyProp
    });
    return (e, o) => {
      const p = me("dk-icon");
      return e.type !== "textarea" ? (s(), r("div", {
        key: 0,
        class: u(n($)),
        style: v(n(D))
      }, [
        n(l).isPrepend ? (s(), r("div", {
          key: 0,
          class: u(te),
          style: v(n(E))
        }, [
          w(e.$slots, "prepend"),
          n(l).isPrependIcon ? (s(), g(p, {
            key: 0,
            icon: e.prependIcon,
            onClick: ie
          }, null, 8, ["icon"])) : a("", !0),
          B.isPrependText ? (s(), r("span", be, m(e.prependText), 1)) : a("", !0)
        ], 4)) : a("", !0),
        L("div", {
          class: u(n(z))
        }, [
          n(l).isPrefix ? (s(), r("span", Ae, [
            w(e.$slots, "prefix"),
            n(l).isPrefixIcon ? (s(), g(p, {
              key: 0,
              class: u(oe),
              icon: e.prefixIcon,
              size: "19px"
            }, null, 8, ["icon"])) : a("", !0)
          ])) : a("", !0),
          J(L("input", Q({
            ref_key: "input",
            ref: b,
            "onUpdate:modelValue": o[0] || (o[0] = (P) => x.value = P),
            type: n(h)
          }, ce, {
            onKeydown: ye(ue, ["enter"])
          }), null, 16, $e), [
            [ke, x.value]
          ]),
          n(l).isLength ? (s(), r("span", De, m(n(_)), 1)) : a("", !0),
          e.showLength ? (s(), r("span", ze, m(C.value), 1)) : a("", !0),
          n(l).isSuffix ? (s(), r("div", Ee, [
            w(e.$slots, "suffix"),
            n(l).isSuffixIcon ? (s(), g(p, {
              key: 0,
              class: u(se),
              icon: e.suffixIcon
            }, null, 8, ["icon"])) : a("", !0)
          ])) : a("", !0),
          n(l).isClear ? J((s(), g(p, {
            key: 4,
            class: "dk-input-clearable",
            icon: "IconShanchu1",
            onClick: le
          }, null, 512)), [
            [xe, ee.value]
          ]) : a("", !0),
          n(l).isShowPassword ? (s(), g(p, {
            key: 5,
            class: u(pe),
            icon: n(H),
            onClick: ae
          }, null, 8, ["icon"])) : a("", !0)
        ], 2),
        n(l).isAppend ? (s(), r("div", {
          key: 1,
          class: u(ne),
          style: v(n(E))
        }, [
          w(e.$slots, "append"),
          n(l).isAppendIcon ? (s(), g(p, {
            key: 0,
            icon: e.appendIcon,
            onClick: re
          }, null, 8, ["icon"])) : a("", !0),
          B.isAppendText ? (s(), r("span", Re, m(e.appendText), 1)) : a("", !0)
        ], 4)) : a("", !0)
      ], 6)) : (s(), r("div", {
        key: 1,
        class: u(n($)),
        style: v(n(D))
      }, [
        L("textarea", Q({
          ref_key: "textarea",
          ref: A,
          type: n(h)
        }, de), null, 16, Be),
        n(l).isLength ? (s(), r("span", Ke, m(n(_)), 1)) : a("", !0),
        e.showLength ? (s(), r("span", Ne, m(C.value), 1)) : a("", !0)
      ], 6));
    };
  }
});
export {
  qe as default
};
