import type { returnType } from '../../_utils';
import type { PropType, ExtractPropTypes } from 'vue';
export declare const DKshadowProps: {
    type: returnType<PropType<string>, string | null>;
    shadowClass: returnType<PropType<string>, string | null>;
    hoverType: returnType<BooleanConstructor, boolean>;
    hoverClass: returnType<PropType<string>, string | null>;
    borderColor: returnType<PropType<string>, string | null>;
};
export type dkshadowProps = ExtractPropTypes<typeof DKshadowProps>;
urnType<PropType<string>, string | null>;
}, {
    DkShadow: Ref<HTMLButtonElement | undefined>;
    type: ComputedRef<string>;
    shadowClass: ComputedRef<string>;
    hoverType: ComputedRef<boolean>;
    onhoverType: () => void;
    oncloshoverType: () => void;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    type: returnType<PropType<string>, string | null>;
    shadowClass: returnType<PropType<string>, string | null>;
    hoverType: returnType<BooleanConstructor, boolean>;
    hoverClass: returnType<PropType<string>, string | null>;
    borderColor: returnType<PropType<string>, string | null>;
}>>, {
    type: string;
    borderColor: string;
    shadowClass: string;
    hoverType: boolean;
    hoverClass: string;
}, {}>;
export default _sfc_main;
