import { toRaw as q, useSlots as v, computed as b, reactive as B } from "vue";
import { getColor as a } from "../public/get-color/index.js";
import { getStyleList as I } from "../public/get-StyleList/index.js";
import { setSize as g } from "../public/set-size/index.js";
import "../../_icon/index.js";
const ee = (e) => {
  let t = ["type", "size"];
  const n = { ...q(e) }, r = v(), l = e.prependText || e.prependIcon || r.prepend, s = e.appendText || e.appendIcon || r.append;
  s && l ? (n.appendText = "wrapper-pend_text", n.prependText = "") : (s && (n.appendText = "wrapper-append_text"), l && (n.prependText = "wrapper-prepend_text"));
  const i = n;
  b(() => n.disabled).value && (t = [...t, "disabled"]);
  const { classes: P } = I(i, "input"), k = P([...t], "dk-input"), A = b(() => {
    const {
      width: c,
      height: u,
      fontSize: h,
      borderRadius: m,
      textColor: S,
      iconSize: C,
      align: M,
      borderColor: x,
      focusBorderColor: w,
      border: N
    } = n;
    let y = "transparent", T = "transparent", z = "transparent";
    ((j) => {
      j !== "none" && (y = x ? a(x).getDeepen(0) : null, T = x ? a(x).getDeepen(0.4) : null, z = w ? a(w).getDeepen(0) : null);
    })(N);
    const o = {
      "--input-align": M || "left"
    };
    return w && (o["--input-focus-border"] = z), x && (o["--input-border"] = y, o["--input-hover-border"] = T), c && (o["--input-width"] = g(c)), u && (o["--input-height"] = g(u)), h && (o["--input-font-size"] = g(h)), m && (o["--input-border-radius"] = g(m)), S && (o["--input-text-color"] = a(S).getDeepen(0)), C && (o["--input-icon-size"] = g(C)), o;
  }), R = P([...["appendText", "prependText", "readonly"]], "dk-input-wrapper"), $ = I(i, "input").classes, E = $([...[]], "dk-input_inner"), _ = ["clearable"], O = I(i, "input").classes, V = O([..._], "dk-input"), W = b(() => {
    const { appendBackground: c, appendColor: u } = n;
    return {
      "--pend-background": c ? a(c).getDeepen(0) : null,
      "--pend-hover-background": c ? a(c).getDeepen(0.4) : null,
      "--pend-color": u ? a(u).getDeepen(0) : null
    };
  });
  return {
    classList: k,
    styleList: A,
    wrapperClassList: R,
    innerClassList: E,
    clearableClassList: V,
    pendStyleList: W
  };
}, d = (e) => e.length == 0 ? !1 : e.find((n) => !n) === void 0, p = (e) => e.length == 0 ? !1 : e.find((n) => n) !== void 0, f = (e) => {
  if (!e)
    return !1;
  if (Array.isArray(e)) {
    if (e.length === 0)
      return !1;
  } else if (e = e.toString().trim(), typeof e == "string" && e.length === 0)
    return !1;
  return !0;
}, ne = (e, t) => {
  let n = e;
  return e === "password" ? t ? n = "text" : n = "password" : n = e, n;
}, F = (e, t, n) => {
  const r = p([f(e), f(t)]);
  return d([r, !n]);
}, G = (e, t, n) => d([!t, n !== "textarea", n !== "password", e]), te = (e, t, n, r, l) => {
  typeof e == "number" && (e = e.toString());
  let s = e;
  if (t && !n) {
    const i = new RegExp(`^${t}`);
    s = s.replace(i, "");
  }
  if (r && !l) {
    const i = new RegExp(`${r}$`);
    s = s.replace(i, "");
  }
  return s;
}, re = (e, t, n, r, l) => {
  typeof e == "number" && (e = e.toString());
  let s = e;
  return t && !n && (new RegExp(`^${t}`).test(e) || (s = t + e)), r && !l && (new RegExp(`${r}$`).test(e) || (s = s + r)), s;
}, H = (e, t) => {
  if (!e.showLengthProp)
    return !1;
  let r = !1;
  const i = p([t === "textarea", t === "text"]), L = !e.maxlengthProp;
  return r = d([i, L]), r;
}, se = (e, t, n) => B({
  isPrepend: p([
    !!t.prepend,
    f(e.prependText),
    !!e.prependIcon
  ]),
  isPrependIcon: d([f(e.prependIcon), !t.prepend]),
  isAppendIcon: d([!t.append, !!e.appendIcon]),
  isAppend: p([
    !!t.append,
    f(e.appendText),
    !!e.appendIcon
  ]),
  isPrefixIcon: d([!!e.prefixIcon, !t.prefix]),
  isAppendTextLen: f(e.appendText),
  isPrefix: p([!!t.prefix, !!e.prefixIcon]),
  isClear: G(e.clearable, e.disabledProp, n),
  inputmode: n === "number" ? "numeric" : "text",
  isSuffix: p([!!t.suffix, !!e.suffixIcon]),
  isSuffixIcon: d([!!e.suffixIcon, !t.suffix]),
  isShowPassword: d([n === "password", e.showPassword]),
  isLength: F(
    e.maxlengthProp,
    e.minlengthProp,
    e.disabledProp
  ),
  rows: e.rowsProp || 2,
  showLength: H(e, n)
}), ie = (e) => B({
  prependText: e.prependText,
  appendText: e.appendText,
  placeholder: e.placeholder,
  clearable: e.clearable,
  showPassword: e.showPassword,
  prependIcon: e.prependIcon,
  appendIcon: e.appendIcon,
  disabledProp: e.disabled,
  typeProp: e.type,
  prefixIcon: e.prefixIcon,
  suffixIcon: e.suffixIcon,
  maxlengthProp: e.maxlength,
  minlengthProp: e.minlength,
  autosizeProp: e.autosize,
  rowsProp: e.rows,
  readonlyProp: e.readonly,
  showLengthProp: e.showLength
});
export {
  d as getBooleanAnd,
  p as getBooleanOr,
  ee as getInput,
  G as getIsClear,
  f as getNull,
  re as getPendValue,
  te as getValue,
  F as isShowLength,
  se as setData,
  ie as setPropData,
  ne as verifyInputType
};
