import type { VNode, Component } from 'vue';
export type ClassListName = (string | Record<string, unknown>)[];
export type dkPlusType = 'primary' | 'success' | 'info' | 'warning' | 'danger' | 'default';
export type dkPlusSize = 'large' | 'medium' | 'small' | 'mini';
export type dkTarget = '_blank' | '_self' | '_parent' | '_top';
export type MouseEventType = (evt: MouseEvent) => void;
export type DkIcon = VNode | Component;
export type KeyboardEventType = (evt: KeyboardEvent) => void;
export type DkPlusAlign = 'left' | 'center' | 'right';
export type DkPlusPosition = 'top' | 'right' | 'bottom' | 'left';
export type dkPlusAlertType = 'success' | 'info' | 'warning' | 'error';
