import type { returnType } from '../../_utils';
import type { PropType, ExtractPropTypes } from 'vue';
export declare const iconProps: {
    readonly icon: returnType<PropType<string>, string | null>;
    readonly size: returnType<PropType<string | number>, string | number | null>;
    readonly color: returnType<PropType<string>, string | null>;
};
export type IconProps = ExtractPropTypes<typeof iconProps>;
   readonly color: returnType<PropType<string>, string | null>;
}, {
    style: ComputedRef<CSSProperties>;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    readonly icon: returnType<PropType<string>, string | null>;
    readonly size: returnType<PropType<string | number>, string | number | null>;
    readonly color: returnType<PropType<string>, string | null>;
}>>, {
    readonly size: string | number;
    readonly icon: string;
    readonly color: string;
}, {}>;
export default _sfc_main;
